import Flutter
import UIKit
import AppTrackingTransparency
import AdSupport


public class ChobiAdmobFlutterPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "chobi_admob_flutter", binaryMessenger: registrar.messenger())
    let instance = ChobiAdmobFlutterPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    switch call.method {
    case "getPlatformVersion":
      result("iOS " + UIDevice.current.systemVersion)


    case "confirmAppTrackingTransparency":
        if #available(iOS 14.0, *) {
            ATTrackingManager.requestTrackingAuthorization(completionHandler: { status in
                result(true)
            })
        } else {
            result(true)
        }

    default:
      result(FlutterMethodNotImplemented)
    }
  }
}
